//GLOBAL
var NOTOPCODE=0x100000000,YET=0x100000000+1;
var COMMENT=0x100000000+2,EMPTYLINE=0x100000000+3;
var ASMERR=0x100000000+4,LABEL=0x100000000+5;
var lbl_dict={};
var token_dict={
"rlist":"\{(.+)\}",
"label":"(@.+)",
"h":"r(8|9|10|11|12|13|14|15)",
"reg":"r([0-7])",
"push":"push",
"pop":"pop",
"!":"\\!",
"=":"=",
"<<":"<<",
">>":">>",
"+":"\\+",
"ofs":"([\\+\\-]{1}.+)",
"|":"\\|",
//"n":"((?:\\-|0b|0x)?[0-0a-f]{1,8})",
"n":"(.+)",
"-":"\\-",
"&":"&",
"^":"\\^",
"not":"(?:\\~|not)",

"*":"\\*",
"if":"if",
"goto":"goto",
"ret":"ret",
"":"",
"[":"\\[",
"]":"\\]",
"bl":"([b|l]?)",
"w":"w",
"0":"0",
"data":"data",
"pc":"pc",
"sp":"sp"

}



function patfactory(s){

    s=s.split(" ");
    var p=["^"],i;
    for(i=0;i<s.length;i++){
        p.push(token_dict[s[i].toLowerCase()]);
    }
	p.push("$");
	return RegExp(p.join(""));
}
var b_dict={};
var n_dict={};
function rlist(){
	var pat=/r([0-7])\-r([0-7])/;
	var f=function(d,pc){
		var ret=0,r,i,j,a,rs=d.split(",");
		for(i=0;i<rs.length;i++){
			r=rs[i];
			a=r.match(pat)
			if(a){
				for(j=parseInt(a[1]);j<=parseInt(a[2]);j++){
					ret|=(1<<j);
				}
			}else if (r.charAt(0)=="r"){
				r=parseInt(r.slice(1));
				if(r>=0&&r<8){
					ret|=(1<<r);
				}else if (r==14||r==15){
					ret|=(0x100);
				}else{
					return ASMERR
				}
			}

			else if (r=="pc" || r=="lr"){
				ret|=(0x100);
			}

			
		}

		return ret;
	}
	return f;
}
function lb(pc){

}
function n(bits,s,ofs,div){
	//dat bit shift
	ofs=(ofs!=undefined)?ofs:0;
	div=(div!=undefined)?div:0;
	var mask=Math.pow(2,bits)-1;
	var mx=Math.pow(2,bits-1)-1;
	var mn=-Math.pow(2,bits-1);
	if(mask<1) mask=0;
	var f=function(d,pc){
		var ret,lbl,i;
		ret=d.match(/@\w+/g);
		if (ret!=null){
			for(i=0;i<ret.length;i++){
				lbl=ret[i];
				if ( lbl in lbl_dict){
					rel=(lbl_dict[lbl]-(pc&0x0fffffffc))>>div;
					if (rel>mx||rel<mn){
						return ASMERR
					}
					d=d.replace(lbl,rel,"g")
				}else{
					return YET;
				}
			}
		}
		d=pint(d)+ofs;
		return (d&mask)<<s;
	}
	return f;
}
function b(bits,s,ofs){
	//dat bit shift,ofs
	ofs=(ofs!=undefined)?ofs:0;
	var mask=Math.pow(2,bits)-1;
	if(mask<1) mask=0;
	var f=function(d,pc){
		//console.log(bits,s,ofs);
		
		d=pint(d);

		return (d&mask)<<s;
	}

	return f;

}
function bl(bits,s,ofs){
	//dat bit shift,ofs
	ofs=(ofs!=undefined)?ofs:0;
	var mask=Math.pow(2,bits)-1;
	if(mask<1) mask=0;
	var f=function(d,pc){
		//console.log("d",d);
		d={"":1,undefined:1,"w":0,"b":1}[d];
		d=parseInt(d);

		return (d&mask)<<s;
	}

	return f;

}
function build_m(f,ar,pc){
	var i,op=f[1],_op;

		for(i=1;i<ar.length;i++){
			_op=f[i+1](ar[i],pc);
			if (_op>=NOTOPCODE){
				return _op;
			}else{
				op=op|_op;
			}
		}
		return 0x0ffff&op;
}


var cmdlist=[

//label

//jmp
["if 0 goto n",0xd000,n(8,0,-2,1)],
["if ! 0 goto n",0xd100,n(8,0,-2,1)],
["goto h",0x4740,b(3,3)],
["goto reg",0x4700,b(3,3)],
["goto n",0xe000,n(11,0,-2,2)],


//sp
["reg = sp + n",0xa800,b(3,8),b(8,0,0)],
["reg = [ sp + n ]",0x9800,b(3,8),b(8,0)],
["[ sp + n ] = reg",0x9000,b(8,0),b(3,8)],

//memory
["reg = [ reg + reg ] bl",0x5800,b(3,0),b(3,3),b(3,6),bl(1,10,0)],
["[ reg + reg ] = reg bl",0x5000,b(3,3),b(3,6),b(3,0),bl(1,10,0)],

["reg = [ reg + n ] w",0x8800,b(3,0),b(3,3),b(5,6,0)],
["reg = [ reg + n ] bl",0x6800,b(3,0),b(3,3),b(5,6,0),bl(1,12,0)],

["[ reg + n ] = reg w",0x8000,b(3,3),b(5,6,0),b(3,0),bl(1,12,0)],
["[ reg + n ] = reg bl",0x6000,b(3,3),b(5,6,0),b(3,0),bl(1,12,0)],


["reg + = n",0x3000,b(3,8),b(8,0)],
["reg - = n",0x3800,b(3,8),b(8,0)],
["reg = reg << n",0x0,b(3,0),b(3,3),b(5,6)],
["reg = reg >> n",0x0800,b(3,0),b(3,3),b(5,6)],
["reg = reg + reg",0x1800,b(3,0),b(3,3),b(3,6)],
["reg = reg - reg",0x1a00,b(3,0),b(3,3),b(3,6)],
["reg = reg + n",0x1c00,b(3,0),b(3,3),b(3,6)],
["reg = reg - n",0x1e00,b(3,0),b(3,3),b(3,6)],
["reg & = reg",0x4000,b(3,0),b(3,3)],
["reg ^ = reg",0x4040,b(3,0),b(3,3)],
["reg << = reg",0x4080,b(3,0),b(3,3)],
["reg >> = reg",0x40c0,b(3,0),b(3,3)],
["reg = - reg",0x4240,b(3,0),b(3,3)],
["reg | = reg",0x4300,b(3,0),b(3,3)],
["reg * = reg",0x4340,b(3,0),b(3,3)],
["reg & = not reg",0x4380,b(3,0),b(3,3)],
["reg = not reg",0x43c0,b(3,0),b(3,3)],
//cmp
["reg - n",0x2800,b(3,8),b(8,0)],
["reg - reg",0x4280,b(3,0),b(3,3)],
["reg & reg",0x4200,b(3,0),b(3,3)],
//ret
["ret",0x4770],
//let
["h = h",0x46c0,b(3,0),b(3,3)],
["h = reg",0x4680,b(3,0),b(3,3)],
["reg = h",0x4640,b(3,0),b(3,3)],

["reg = reg",0x4600,b(3,0),b(3,3)],
["reg = pc + n",0xa000,b(3,8),n(8,0,-1,2)],
["reg = label",0xa000,b(3,8),n(8,0,-1,2)],

["reg = [ n ]",0x4800,b(3,8,0),n(8,0,-1,2)],
["reg = n",0x2000,b(3,8),b(8,0,0)],
["push rlist",0xb400,rlist()],
["pop rlist",0xbc00,rlist()],


];

var patlist=[];
var i=0;
for(i=0;i<cmdlist.length;i++){
	patlist.push(patfactory(cmdlist[i][0]));
}
function zero16(x){
	var p=x.toString(16);
	p="00".substr(0,2-p.length)+p;
	return p;
}
function zero2(x){
	var p=x.toString(2);
	p="00000000".substr(0,8-p.length)+p;
	return p;
}
function m2b16(lines,outlist){
	var p,p0,p1;
	var bas="",i,line,out,nln;
	var skips={undefined:true,LABEL:true,COMMENT:true,NOTOPCODE:true};
	var lines2=[],linehex=[],lineadr=-1;

	nln=10;
	
	for(i=0; i<outlist.length; i++){
		out=outlist[i];
		l=out[0];
		a=out[1];
		p=out[2];
		line=lines[l];

		if(p==EMPTYLINE){
			continue;
		}else if(p===undefined||p===null||p===false||p>=NOTOPCODE){
			continue
		}else{
			if(lineadr<0){
				lineadr=a;
			}
			p0=p&0x0ff; p1=(p>>8)&0x0ff
			p0=zero16(p0);p1=zero16(p1);
			linehex.push("#"+p0.toString(16));
			linehex.push("#"+p1.toString(16));
		}
		if(linehex.length>=8){
			lines2.push(""+nln.toString(10)+" poke #"+lineadr.toString(16)+
			","+linehex.join(","));
			linehex=[];
			nln+=10;
			lineadr=-1;
		}
	}
	if(linehex.length>0){
		lines2.push(""+nln.toString(10)+" poke #"+lineadr.toString(16)+
		","+linehex.join(","));
	}
	lines2.push("");

	bas=lines2.join("\n");
	return bas;
}
function m2b2(lines,outlist){
	var p,p0,p1;
	var bas="",i,line,out,nln;
	var skips={undefined:true,LABEL:true,COMMENT:true,NOTOPCODE:true};
	for(i=0; i<outlist.length; i++){
		out=outlist[i];
		l=out[0];
		a=out[1];
		p=out[2];
		line=lines[l];

		if(p==EMPTYLINE){
			continue;
		}else if(p===undefined||p===null||p===false||p>=NOTOPCODE){
			nln=i*10+10;
			bas+=""+nln+"'"+line+"\n";
		}else{

			p0=p&0x0ff; p1=(p>>8)&0x0ff
			p0=zero2(p0);p1=zero2(p1);
			nln=i*10+10;
			bas+=""+nln+" "+"poke #"+a.toString(16)+
			",`"+p0+",`"+p1+
			" :'"+line+"\n";
		}
	}
	return bas;
}
function m2bin(lines,outlist){
	var p,p0,p1;
	var bas="",i,line,out,nln;
	var skips={undefined:true,LABEL:true,COMMENT:true,NOTOPCODE:true};
	for(i=0; i<outlist.length; i++){
		out=outlist[i];
		l=out[0];
		a=out[1];
		p=out[2];
		line=lines[l];

		if(p==EMPTYLINE){
			continue;
		}else if(p===undefined||p===null||p===false||p>=NOTOPCODE){
		}else{
			p0=p&0x0ff; p1=(p>>8)&0x0ff
			p0=zero2(p0);p1=zero2(p1);
			bas+=""+p1+p0+"\n";
		}
	}
	return bas;
}

function asmln(ln,prgctr){



	var p,m,j;
	//ln=ln.toLowerCase().replace(/\s/g,"");
	for(j=0;j<patlist.length;j++){
		m=ln.match(patlist[j]);
		if(m){
			console.log(cmdlist[j][0]);
			p=build_m(cmdlist[j],m,prgctr);
			return p;
		}
	}
	return undefined;

}
function pint(s){
	return parseInt(eval(s.replace(/#/g,"0x").replace(/'/g,"0b")));
}

function pdat(ln,pc){
	var dtype=ln.charAt(4),start;
	var sz,sz_dict={"b":1,"w":2,"l":4};
	if (dtype in sz_dict){
		sz=sz_dict[dtype];
		start=5;
	}else{
		sz=1;
		start=4;
	}
	
	ln=ln.replace(/#/g,"0x").replace(/\'/g,"0b")
	var dlist=ln.slice(start).split(",")
	var i,d,ret=[];
	var adr=0;
	var msk=Math.pow(2,8*sz)-1;
	for(i=0;i<dlist.length;i++){
		d=pint(dlist[i]);
		ret.push(d&msk);
	}
	var _ret;
	if (sz==1){
		_ret=ret
		ret=[];
		if(_ret.length%2){
			_ret.push(0);
		};
		for(i=0;i<_ret.length;i+=2){
			ret.push(_ret[i]|(_ret[i+1]<<8));
		}
	}else if (sz==4){
		_ret=ret;
		ret=[];
		//align
		if (pc%4==2){
			ret.unshift(0xffff);
		};
		
		for(i=0;i<_ret.length;i++){
			ret.push(_ret[i]&0xffff);
			ret.push((_ret[i]>>16)&0xffff);
		}
	}
	return ret

}
function sublbl(d,pc){
	var ret,lbl,i;
	ret=d.match(/@\w+/g);
	if (ret!=null){
		for(i=0;i<ret.length;i++){
			lbl=ret[i];
			if ( lbl in lbl_dict){
				rel=(lbl_dict[lbl]-pc);
				d=d.replace(lbl,rel,"g")
			}else{
				return YET;
			}
		}
	}
	d=pint(d);
	return d;
}
function gsb(d,pc){
	var rel=sublbl(d,pc);
	var h,l,ret;
	if (rel==YET){
		ret= YET;
	}else  {
		rel=rel-4;
		h=(rel>>12)&0x7ff;
		l=(rel>>1)&0x7ff;
		ret= [0xf000|h,0xf800|l];
		
	}
	return ret;
}

var bas="";
var outlist=[];
var fmt_dict={"bas2":m2b2,"bas16":m2b16,"bin":m2bin};
function asemble(){
	lbl_dict={};
	outlist=[];
	var PrgCtr=0;
	var arg;
	dom_src=document.getElementById("textarea1");
	dom_fmt=document.getElementById("selfmt");
	dom_hex=document.getElementById("textarea2");
	dom_err=document.getElementById("textarea3");
	dom_adr=document.getElementById("txtadr");
	var fmt=dom_fmt.value,fm2b=fmt_dict[fmt];
	var lines=(""+dom_src.value).split("\n");
	var i,j,line,m,p,p1,p2;
	var lno;
	dom_hex.innerHTML=""
	PrgCtr=pint(dom_adr.value);
	bas="";
	
	for(i=0;i<lines.length;i++){
		line=lines[i].toLowerCase().replace(/\s/g,"");
		lines[i]=line;

		if (line.charAt(0)=="@"){
			lbl_dict[line]=PrgCtr;
			outlist.push([i,PrgCtr,LABEL]);
			continue;
		}else if(line.charAt(0)=="'"||line.slice(0,3)=="rem"){

			outlist.push([i,PrgCtr,COMMENT]);
			continue;
		} else if (line.slice(0,5)=="gosub"){
			p=gsb(line.slice(5),PrgCtr);
			if (p==YET){
				p1=YET;p2=YET;
			} else {
				p1=p[0]; p2=p[1];
			}
			outlist.push([i,PrgCtr,p1]);
			outlist.push([i,PrgCtr+2,p2]);
			PrgCtr+=4;
		}else if(line.slice(0,4)=="data"){
			dlist=pdat(line,PrgCtr);
			for(j=0;j<dlist.length;j++){
				outlist.push([i,PrgCtr,dlist[j]]);
				PrgCtr+=2;
				
			}
			continue;
		} else if(line==""){

			outlist.push([i,PrgCtr,EMPTYLINE]);
			continue;
			

		}else{
			p=asmln(line,PrgCtr);
			outlist.push([i,PrgCtr,p]);
			if (p!=undefined){
				PrgCtr+=2;
			}
		}
	}
	
	for(i=0;i<outlist.length;i++){

		lno=outlist[i][0];
		PrgCtr=outlist[i][1];
		p=outlist[i][2];
		line=lines[lno];
		if (p>=NOTOPCODE){

		}
		if(p==YET){
			if(line.slice(0,5)=="gosub"){
				p=gsb(line.slice(5),PrgCtr);
				p1=p[0];p2=p[1];
				outlist[i]=[lno,PrgCtr,p1];
				outlist[i+1]=[lno,PrgCtr+2,p2];
				i++;
			} else {
				p=asmln(line,PrgCtr);
				outlist[i]=[lno,PrgCtr,p];
			}
		}
	}
	bas=fm2b(lines,outlist);
	dom_hex.value=bas;
	if(dom_hex.textContent==bas) return;
	dom_hex.textContent=bas;
	if(dom_hex.textContent==bas) return;
	dom_hex.innerText=bas;
	if(dom_hex.innerText==bas) return;
	dom_hex.innerHTML=bas;
	if(dom_hex.innerHTML==bas) return;

}


function example(){
	var dom_src=document.getElementById("textarea1");
	var dom_ex=document.getElementById("selex");
	var exname=dom_ex.value;
	if (!exname){
		return false;
	}
	var res = confirm("Load example '"+exname+"' ?");
	if (!res){
		return false;
	} 
	extxt=ex_dict[exname];
	dom_src.value=extxt;
	if(dom_src.textContent==extxt) return;
	dom_src.textContent=extxt;
	if(dom_src.textContent==extxt) return;
	dom_src.innerText=extxt;
	if(dom_src.innerText==extxt) return;
	dom_src.innerHTML=extxt;
	if(dom_src.innerHTML==extxt) return;
}

